
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【增强学习】Recurrent Visual Attention源码解读 / 憋错料</title>

    <meta name="description" content="【增强学习】Recurrent Visual Attention源码解读 Mnih, Volodymyr, Nicolas Heess, and Alex Graves. &quot;Recurrent models of visual attention.&quot; Advances in Neural Information Processing Systems. 2014. 戳这里下载训练代码,戳这里下载测试代码. 这篇文章处理的任务非常简单:MNIST手写数字分类.但使用了聚焦机制(Visual Attention),不是一次看一张大图进行估计,而是分多次观 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">【增强学习】Recurrent Visual Attention源码解读</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<blockquote><p>Mnih, Volodymyr, Nicolas Heess, and Alex Graves. “Recurrent models of visual attention.” Advances in Neural Information Processing Systems. 2014.</p></blockquote>
<p>戳<a href="https://github.com/Element-Research/rnn/blob/master/examples/recurrent-visual-attention.lua" rel="external nofollow noreferrer"><strong>这里</strong></a>下载训练代码，戳<a href="https://github.com/Element-Research/rnn/blob/master/scripts/evaluate-rva.lua" rel="external nofollow noreferrer"><strong>这里</strong></a>下载测试代码。</p>
<p>这篇文章处理的任务非常简单：MNIST手写数字分类。但使用了聚焦机制(Visual Attention)，不是一次看一张大图进行估计，而是<strong>分多次观察小部分图像，根据每次查看结果移动观察位置，最后估计结果</strong>。</p>
<p>Yoshua Bengio的高徒，先后供职于LISA和Element Research的<a href="https://github.com/nicholas-leonard" rel="external nofollow noreferrer">Nicolas Leonard</a>用Torch实现了这篇文章的算法。Torch官方cheetsheet的demo中，就包含这篇源码，作者自己的讲解也刊登在Torch的<a href="http://torch.ch/blog/2015/09/21/rmva.html" rel="external nofollow noreferrer">博客</a>中，足见其重要性。</p>
<p>通过这篇源码，我们可以</p>
<p>- 理解<strong>聚焦机制</strong>中较简单的hard attention</p>
<p>- 了解<strong>增强学习</strong>的基本流程</p>
<p>- 复习Torch和扩展包dp的相关语法</p>
<p>本文解读训练源码，分三大部分：参数设置，网络构造，训练设置。以下逐次介绍其中重要的语句。</p>
<h1>参数设置</h1>
<p>除了Torch之外，还需要包含Nicholas Leonard自己编写的两个包。<a href="https://github.com/nicholas-leonard/dp" rel="external nofollow noreferrer">dp</a>：能够简化DL流程，训练过程更“面向对象”；<a href="https://github.com/Element-Research/rnn" rel="external nofollow noreferrer">rnn</a>：实现Recurrent网络。</p>
<pre><code>require ‘dp‘
require ‘rnn‘</code></pre>
<p>首先使用Torch的<code>CmdLine</code>类设定一系列参数，存储在<code>opt</code>中。这是Torch的标准写法。</p>
<pre><code>cmd = torch.CmdLine()
cmd:option(‘--learningRate‘, 0.01, ‘learning rate at t=0‘)    -- 参数名,参数值,说明
local opt = cmd:parse(arg or {})    --把cmd中的参数传入opt</code></pre>
<p>把数据载入到数据集<code>ds</code>中，数据是dp包中已经下载好的：</p>
<pre><code>ds = dp[opt.dataset]()</code></pre>
<h1>网络构造</h1>
<p>这篇源码中模型的写法遵循：由底到顶，先细节后整体。和CNN不同，Recurrent网络带有反馈，呈现较为复杂的多级嵌套结构。请着重关注每个模块的<strong>输入</strong>、<strong>输出</strong>和<strong>作用</strong>部分。</p>
<h2>Glimpse网络</h2>
<p><strong>输入</strong>：图像I和观察位置l</p>
<p><strong>输出</strong>：观察结果x</p>
<p>蓝色输入，橙色输出，菱形表示串接：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA2MDUyMzAyMzkyNzI=.jpg"></p>
<p>首先用<code>locationSensor</code>（左半）提取位置信息l中的特征：</p>
<pre><code>locationSensor:add(nn.SelectTable(2))    --选择两个输入中的第二个，位置l
locationSensor:add(nn.Linear(2, opt.locatorHiddenSize))    --Torch中的Linear指全连层
locationSensor:add(nn[opt.transfer]())    --opt.transfer定义一种非线性运算，本文中是ReLU</code></pre>
<p>之后用<code>glimpseSensor</code>（右半）提取图像I位置l的特征。</p>
<p>其中SpacialGlimpse是dp中定义的层，提取尺寸为PatchSize的Depth层图像，相邻层比例为Scale。</p>
<pre><code>glimpseSensor:add(nn.SpatialGlimpse(opt.glimpsePatchSize, opt.glimpseDepth, opt.glimpseScale):float())    --SpatialGlimpse提取小块金字塔
glimpseSensor:add(nn.Collapse(3))    --压缩第三维
glimpseSensor:add(nn.Linear(ds:imageSize(‘c‘)*(opt.glimpsePatchSize^2)*opt.glimpseDepth, opt.glimpseHiddenSize))
glimpseSensor:add(nn[opt.transfer]())</code></pre>
<p>两者结果串接为<code>glimpse</code>，输出包含位置和纹理信息的x，尺寸为hiddenSize：</p>
<pre><code>glimpse:add(nn.ConcatTable():add(locationSensor):add(glimpseSensor))
glimpse:add(nn.JoinTable(1,1))    --把串接数据合并成一个Tensor
glimpse:add(nn.Linear(opt.glimpseHiddenSize+opt.locatorHiddenSize, opt.imageHiddenSize))
glimpse:add(nn[opt.transfer]())
glimpse:add(nn.Linear(opt.imageHiddenSize, opt.hiddenSize))    --从imageHiddenSize到hiddenSize的全连层</code></pre>
<p><strong>作用</strong>：通过小范围观测，提取纹理和位置信息。</p>
<blockquote><p><strong>说明</strong></p>
<p>Torch的基础数据是Tensor，而lua中用Table实现类似数组的功能。nn库中专门有<a href="https://github.com/torch/nn/blob/master/doc/table.md" rel="external nofollow noreferrer">一系列Table层</a>，用于处理涉及这两者的运算。例如：</p>
<p><code>ConcatTable</code> - 把若干个输出Tensor放置在一个Table中。</p>
<p><code>SelectTable</code> - 从输入的Table中选择一个Tensor。</p>
<p><code>JoinTable</code> - 把输入Table中的所有Tensor合并成一个Tensor。</p></blockquote>
<h2>Recurrent网络</h2>
<p><strong>输入</strong>：和Glimpse网络相同，图像I，观察位置l。</p>
<p><strong>输出</strong>：系统循环状态r</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA2MDUyMzA0MDUzOTg=.jpg"></p>
<p>使用Recurrent类创建一个包含Glimpse子网络的<code>rnn</code>框架。Recurrent类的第二个参数(glimpse)指出如何处理输入，第三个参数(recurrent)指出如何处理前一时刻的循环状态。</p>
<pre><code>recurrent = nn.Linear(opt.hiddenSize, opt.hiddenSize)
rnn = nn.Recurrent(opt.hiddenSize, glimpse, recurrent, nn[opt.transfer](), 99999)</code></pre>
<p><strong>作用</strong>：通过小范围观测，更新网络循环状态。</p>
<h2>Locator网络</h2>
<p><strong>输入</strong>：系统循环状态r，也就是Recurrent网络的输出</p>
<p><strong>输出</strong>：观测位置l</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA2MDUyMzA0MzcxNjQ=.jpg"></p>
<p>这部分核心是dp库中的<a href="https://github.com/nicholas-leonard/dpnn#nn.ReinforceNormal" rel="external nofollow noreferrer"><code>ReinforceNormal</code></a>层：正态分布的强化学习层。dp库中还有其他分布的强化学习层。</p>
<pre><code>locator:add(nn.Linear(opt.hiddenSize, 2))
locator:add(nn.HardTanh()) -- bounds mean between -1 and 1
locator:add(nn.ReinforceNormal(2*opt.locatorStd, opt.stochastic)) -- sample from normal, uses REINFORCE learning rule
locator:add(nn.HardTanh()) -- bounds sample between -1 and 1
locator:add(nn.MulConstant(opt.unitPixels*2/ds:imageSize("h")))    --对位置l做了归一化：相对图像中心的最大偏移为unitPixel。</code></pre>
<p><code>ReinforceNormal</code>层在训练状态下，会以前一层输入为均值，以第一个参数（2*opt.locatorStd）为方差，产生符合高斯分布采样结果；</p>
<p>在训练状态下，如果第二个参数（opt.stochastic）为真，则以相同方式采样，否则直接传递前一层结果。</p>
<p>简单来说，<strong>Reinforce层的作用是：在训练时，围绕当前策略</strong>（前层输出），<strong>探索一些新策略</strong>（高斯采样）。具体怎么训练在下篇再说。</p>
<p><strong>作用</strong>：利用系统循环状态，决定观测位置。</p>
<h2>Attention网络</h2>
<p><strong>输入</strong>：图像I</p>
<p><strong>输出</strong>：系统循环状态r</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA2MDUyMzA1MTEyMjg=.jpg"></p>
<p>直接使用rnn包中的<a href="https://github.com/Element-Research/rnn#rnn.RecurrentAttention" rel="external nofollow noreferrer">RecurrentAttention</a>层进行定义。第一个参数(rnn)指明如何处理循环状态r的记忆，第二个参数(locator)指明利用循环状态执行何种动作(action)。</p>
<pre><code>attention = nn.RecurrentAttention(rnn, locator, opt.rho, {opt.hiddenSize})</code></pre>
<p><strong>作用</strong>：利用图像更新系统循环状态。</p>
<h2>Agent网络</h2>
<p><strong>输入</strong>：图像I</p>
<p><strong>输出</strong>：字符属于各类的概率向量p</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA2MDUyMzA2MDE0MTY=.jpg"></p>
<p>在前面<code>attention</code>网络的基础上，只对系统循环变量做简单非线性变换，即得到图像属于各类字符的概率p。</p>
<pre><code>agent:add(attention)
agent:add(nn.SelectTable(-1))
agent:add(nn.Linear(opt.hiddenSize, #ds:classes()))
agent:add(nn.LogSoftMax())    -- 这里输出分类结果</code></pre>
<p>由于系统中存在强化学习层<code>ReinforceNormal</code>，所以需要一个baseline变量b。这里利用<code>ConcatTable</code>把b和分类结果合并到一个Table里输出。</p>
<pre><code>seq:add(nn.Constant(1,1))
seq:add(nn.Add(1))
concat = nn.ConcatTable():add(nn.Identity()):add(seq)
concat2 = nn.ConcatTable():add(nn.Identity()):add(concat)
agent:add(concat2)</code></pre>
<p>整个系有两组输出：分类结果p，以及分类结果+baseline对{p,b}。</p>
<p><strong>作用</strong>：把系统隐变量转化成估计结果，并且输出一个baseline，便于后续优化。</p>
<h1>训练设置</h1>
<p>在dp库中，训练过程是分层定义的，为了说明清晰，倒序讲解。</p>
<p>首先（在代码里是最后），定义实验<code>xp</code>，使用的模型就是前述网络<code>agent</code>：</p>
<pre><code>xp = dp.Experiment{
   model = agent,       -- nn.Sequential, 待优化模型
   optimizer = train,   -- dp.Optimizer，训练
   validator = valid,   -- dp.Evaluator，验证
   tester = tester,     -- dp.Evaluator，测试
   observer = {         -- 设定log
      ad,
      dp.FileLogger(),
      dp.EarlyStopper{
         max_epochs = opt.maxTries,
         error_report={‘validator‘,‘feedback‘,‘confusion‘,‘accuracy‘},
         maximize = true
      }
   },
   random_seed = os.time(),
   max_epoch = opt.maxEpoch   -- 最大迭代次数
}</code></pre>
<h2>训练</h2>
<p><code>train</code>是一个<a href="https://github.com/nicholas-leonard/dp/blob/master/propagator/optimizer.lua" rel="external nofollow noreferrer"><code>dp.Optimizer</code></a>类型对象，这个类继承自抽象类<code>dp.propogator</code>，需要指明6个参数：</p>
<pre><code>train = dp.Optimizer{
    loss=..., epoch_callback=..., callback = ..., feedback - ...,sampler = ..., progress = ...
}</code></pre>
<p><code>loss</code>定义了损失层。用<code>ParallelCriterion</code>把监督学习的<code>ClassNLLCriterion</code>和增强学习的<code>VRClassReward</code>并列优化。</p>
<pre><code>loss = nn.ParallelCriterion(true)
    :add(nn.ModuleCriterion(nn.ClassNLLCriterion(), nil,nn.Convert())) --  监督学习：negative log-likelihood
    :add(nn.ModuleCriterion(nn.VRClassReward(agent, opt.rewardScale), nil, nn.Convert())) -- 增强学习：得分最高类与标定相同反馈1，否则反馈-1</code></pre>
<p><code>epoch_callback</code>函数设定每个epoch结束时执行的动作，一般用来调整<code>opt</code>中的学习率。</p>
<pre><code>epoch_callback = function(model, report) -- called every epoch
  if report.epoch &gt; 0 then
     opt.learningRate = opt.learningRate + opt.decayFactor
     opt.learningRate = math.max(opt.minLR, opt.learningRate)
     if not opt.silent then
        print("learningRate", opt.learningRate)
     end
  end
end</code></pre>
<p><code>callback</code>是核心函数，更新模型参数：</p>
<pre><code>callback = function(model, report)
    if opt.cutoffNorm &gt; 0 then
        local norm = model:gradParamClip(opt.cutoffNorm) -- dpnn扩展，约束梯度，有益于RNN
        opt.meanNorm = opt.meanNorm and (opt.meanNorm*0.9 + norm*0.1) or norm;
        if opt.lastEpoch &lt; report.epoch and not opt.silent then
            print("mean gradParam norm", opt.meanNorm)
        end
    end
    model:updateGradParameters(opt.momentum) -- dpnn扩展，根据momentum更新梯度
    model:updateParameters(opt.learningRate) -- 根据学习率更新参数
    model:maxParamNorm(opt.maxOutNorm) -- dpnn扩展，约束参数范围
    model:zeroGradParameters() -- 梯度置零
end</code></pre>
<p><code>feedback</code>提供I/O用来生成报告，这里输出分类结果与真值比较的confusion matrix。回忆一下：网络的输出是{p,{p,b}}，所以真正的输出用<code>SelectTable(1)</code>获得。</p>
<pre><code>feedback = dp.Confusion{output_module=nn.SelectTable(1)}</code></pre>
<p><code>sampler</code>决定如何从训练集中采样：设定epoch和batch大小。</p>
<pre><code>sampler = dp.ShuffleSampler{
    epoch_size = opt.trainEpochSize, batch_size = opt.batchSize
   }</code></pre>
<p><code>progress</code>是个布尔型，控制是否显示进度条。</p>
<pre><code>progress = opt.progress</code></pre>
<h2>验证与测试</h2>
<p><code>valid</code>是一个<a href="http://dp.readthedocs.io/en/latest/propagator/index.html#evaluator" rel="external nofollow noreferrer"><code>dp.Evaluator</code></a>类成员变量，同样继承自<code>dp.propogator</code>。只需要指明<code>feedback</code>，<code>sampler</code>，<code>progress</code>这三个参数即可。</p>
<pre><code>valid = dp.Evaluator{
   feedback = dp.Confusion{output_module=nn.SelectTable(1)},
   sampler = dp.Sampler{epoch_size = opt.validEpochSize, batch_size = opt.batchSize},
   progress = opt.progress
}</code></pre>
<p><code>test</code>和<code>valid</code>类似，连进度条都不用打了</p>
<pre><code>tester = dp.Evaluator{
  feedback = dp.Confusion{output_module=nn.SelectTable(1)},
  sampler = dp.Sampler{batch_size = opt.batchSize}
}</code></pre>
<h2>执行</h2>
<p>在这一步，把已经读取好的数据集<code>ds</code>输入到实验<code>xp</code>中去：</p>
<pre><code>xp:run(ds)</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 23:11:41 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>【增强学习】Recurrent Visual Attention源码解读的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/472Y2x3.html" rel="bookmark">源码解读&mdash;HashTable</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇学习过HashMap(源码解读—HashMap)之后对hashTable也产生了兴趣,随即便把hashTable的源码看了一下.和hashMap类似,但是也有不同之处. public class Hashtable&lt;K,V&gt; extends Dictionary&lt;K,V&gt; implements Map&lt;K,V&gt;, Cloneable, java.io.Serializable  实现接口:Map,Cloneable,Serializable 继承自Diction			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mzo1AW0.html" rel="bookmark">Spark学习之路 （十六）SparkCore的源码解读（二）spark-submit提交脚本</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				讨论QQ:1586558083 目录 一.概述 二.源码解读 2.2 find-spark-home 2.3 spark-class 2.4 SparkSubmit 正文 回到顶部 一.概述 上一篇主要是介绍了spark启动的一些脚本,这篇主要分析一下Spark源码中提交任务脚本的处理逻辑,从spark-submit一步步深入进去看看任务提交的整体流程,首先看一下整体的流程概要图: 回到顶部 二.源码解读 2.1 spark-submit # -z是检查后面变量是否为空(空则真) shell可以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pqdRwM.html" rel="bookmark">seajs 源码解读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前面试时老问一个问题seajs 是怎么加载js 文件的 在网上找一些资料,觉得这个写的不错就转载了,记录一下,也学习一下 seajs 简单介绍 seajs是前端应用模块化开发的一种很好的解决方案.对于多人协作开发的.复杂庞大的前端项目尤其有用.简单的介绍不多说,大家可以到seajs的官网seajs.org参看介绍.本文主要简单地解读一下seajs的源码和模块化原理.如果有描述不实的地方,希望大家指正和交流.注:本文的解析是基于seajs的2.2.1版本. 目录结构 解压seajs之后的src目			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/V02DYp4.html" rel="bookmark">QCustomplot使用分享&lpar;二&rpar; 源码解读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.头文件概述 从这篇文章开始,我们将正式的进入到QCustomPlot的实践学习中来,首先我们先来学习下QCustomPlot的类图,如果下载了QCustomPlot源码的同学可以自己去QCustomPlot的目录下documentation/qcustomplot下寻找一个名字叫做index.html的文件,将其在浏览器中打开,也是可以找到这个库的类图.如图1所示,是组成一个QCustomPlot类图的可能组成形式. 一个图表(QCustomPlot):包含一个或者多个图层.一个或多个ite			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35V1zv4.html" rel="bookmark">jdk1&period;8&period;0&lowbar;45源码解读&mdash;&mdash;HashMap的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jdk1.8.0_45源码解读——HashMap的实现 一.HashMap概述 HashMap是基于哈希表的Map接口实现的,此实现提供所有可选的映射操作.存储的是&lt;key,value&gt;对的映射,允许多个null值和一个null键.但此类不保证映射的顺序,特别是它不保证该顺序恒久不变.  除了HashMap是非同步以及允许使用null外,HashMap 类与 Hashtable大致相同. 此实现假定哈希函数将元素适当地分布在各桶之间,可为基本操作(get 和 put)提供稳定的性能.迭代col			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0d9BKr3.html" rel="bookmark">基于Docker的TensorFlow机器学习框架搭建和实例源码解读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述:基于Docker的TensorFlow机器学习框架搭建和实例源码解读,TensorFlow作为最火热的机器学习框架之一,Docker是的容器,可以很好的结合起来,为机器学习或者科研人员提供便捷的机器学习开发环境,探索人工智能的奥秘,容器随开随用方便快捷.源码解析TensorFlow容器创建和示例程序运行,为热爱机器学者降低学习难度. 默认机器已经装好了Docker(Docker安装和使用可以看我另一篇博文:Ubuntu16.04安装Docker1.12+开发实例+hello world+w			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBaPEA4.html" rel="bookmark">jQuery源码解读第4章---对extend的解读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为什么我们一开始就说extend呢 其实我读源码的过程中,发现其实我们方法就在源码中都调用了extend Callbacks Deferred这些工具方法 所以我们很有必要先学习这些,,,,,,,,,,,这样对我们后续的学习很有帮助 对extend的学习,,,,,首先看下extend我们平时是怎么用的 1...合并对象 extend(dest,src1,src2,,,,,) 它的含义就是将src1,src2......合并到dest中 然后放回的结果就是合并后的dest eq: var dest			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wNnl10.html" rel="bookmark">struct2源码解读（1）之struts2启动</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				struct2源码解读(1)之struts启动 之前用struct2.spring.hibernate在开发一个电子商城,每天都在重复敲代码,感觉对struct2.spring.hibernate的理解都在使用层面上,虽然敲了几个月代码,但是技术水平还是得不到显著提高.于是就想着研究下struct2.spring.hibernate的源码,研究完后不仅对struct2.spring.hibernate加深了了解,同时也加强了java的学习,例如xml的解析,字符操作,线程等等,受益匪浅.想着当初			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGnln64.html" rel="bookmark">Redis内存管理的基石zmallc&period;c源码解读（附录）：源码结构表</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Redis内存管理的基石zmallc.c源码解读(一) Redis内存管理的基石zmallc.c源码解读(二) 前面两篇博文,细致地介绍了zmalloc.c文件的各个函数,不过大家要想深入学习Redis,还需要自己去看源码才是,我梳理了一下zmalloc.c文件的结构,为大家阅读源码提供便利. 全局变量 名称 类型 说明 used_memory static size_t Redis已用内存空间的大小 zmalloc_thread_safe static int 标识是否线程安全 used_me			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n3ZpJlM.html" rel="bookmark" class="title">【云迁移论文笔记】Cloud Migration Research&colon;A Systematic Review</a>
					<div>
						Cloud Migration Research:A Systematic Review Author Info: Pooyan Jamshidi PhD Postdoctoral Researche ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0eWjD4.html" rel="bookmark" class="title">Centos之帮助命令</a>
					<div>
						帮助命令man  (manual) 比如我们可以看下man命令的解释 [[email protected] ~]# man man MAN(1)                             ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6NDkNM.html" rel="bookmark" class="title">&lbrack;Java集合&rsqb; 彻底搞懂HashMap&comma;HashTable&comma;ConcurrentHashMap之关联&period;</a>
					<div>
						注: 今天看到的一篇讲hashMap,hashTable,concurrentHashMap很透彻的一篇文章, 感谢原作者的分享. 原文地址: http://blog.csdn.net/zhanger ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My57pLM.html" rel="bookmark" class="title">两个数字交换（不使用临时变量）</a>
					<div>
						#include&lt;stdio.h&gt; #include&lt;stdlib.h&gt; void swap(int* a, int* b)//普通交换 {  int tmp = *a;  * ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZYJPg0.html" rel="bookmark" class="title">1224字典dictionary</a>
					<div>
						不可变词典NSDictionary 字典没有顺序可言,键值对 Key-Value 键(字符串对象)-值(对象) 0.字典里面多个键值对的值可以相同,但是键不能相同,必须唯一 1.字典存储的优势 a.方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8qYQ0.html" rel="bookmark" class="title">Fiddler实战深入研究&lpar;二&rpar;</a>
					<div>
						阅读目录 Fiddler不能捕获chrome的session的设置 理解数据包统计 请求重定向(AutoResponder) Composer选项卡 Filters选项卡断点调式 Fiddler 中的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6189v4.html" rel="bookmark" class="title">我在寻求工作治理的方法（转）</a>
					<div>
						我一直试图寻求一种规范的管理员工的方法.但我没有找到. 分析了一下,原因如下: 1,公司本身管理混乱,没有成文的管理制度,制度就是老板的口谕,而且朝令夕改,让人摸不着头脑 .    2,没有取得公司顶 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/418nbo3.html" rel="bookmark" class="title">【HDOJ】1341 Simple Computers</a>
					<div>
						注意PC要与31. 1 #include &lt;cstdio&gt; 2 #include &lt;cstring&gt; 3 #include &lt;cstdlib&gt; 4 5 #defin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mom5GD3.html" rel="bookmark" class="title">MySQLdb的安装</a>
					<div>
						安装时切记下载和操作系统相匹配的MySQLdb 推荐使用setuptools安装MySQLdb 命令:easy_install mysql-python 安装前必须安装:VCForPython27.m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPDJqaM.html" rel="bookmark" class="title">定位的层级</a>
					<div>
						如果只给一个元素绝对定位,而不写trbl值的话,会以原位显示 定位(相对和绝对或固定)的元素都有一个层级的属性或是概念.如果定位了的相邻多个元素,在同一个位置的话,后面的元素默认会压住前面的元素.如果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Qqq5w4.html" rel="bookmark" class="title">协议练习改成block</a>
					<div>
						更改协议成block,运行,设置一个头文件person.h #import &lt;Foundation/Foundation.h&gt; @interface Person : NSObject @ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MElZKK4.html" rel="bookmark" class="title">cocos3&period;8&period;1  解决安卓proj&period;android 不可复制的问题</a>
					<div>
						方案1: 方法2:					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JyllQ3.html" rel="bookmark" class="title">定格动画制作用什么软件好？</a>
					<div>
						动画是儿时最好的伙伴,如&lt;葫芦娃&gt;.&lt;西游记&gt;等定格动画都伴着我们成长,留在了童年的记忆中.现在动手制作儿时的动画,已不是什么难事,自己也能动作制作了.那么定格动画制作用什么软 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVzB2wM.html" rel="bookmark" class="title">杭电2019</a>
					<div>
						#include &lt;iostream&gt; #include &lt;cstdlib&gt; #include &lt;cmath&gt; #include &lt;iomanip&gt; # ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6zyWNM.html" rel="bookmark" class="title">c&plus;&plus;  二叉树的遍历</a>
					<div>
						#include &lt;stdio.h&gt; #include &lt;stdlib.h&gt; #include &lt;string.h&gt; #include &lt;ctype.h&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lk2oNM.html" rel="bookmark" class="title">new-nav-html</a>
					<div>
						&lt;header id=&quot;masthead&quot; class=&quot;masthead&quot; role=&quot;banner&quot;&gt; &lt;h1 cla ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R7o5v3.html" rel="bookmark" class="title">java服务器客户端程序在联机运行时被防火墙拦截</a>
					<div>
						最近在myeclipse上写了份网络象棋的代码,包含服务器端和客户端,让朋友下载后运行客户端,连不上我开的服务器,但我关闭自己的防火墙后他才连上,我尝试把程序设为防火墙信用程序,但不行,求大神指导!! ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41zx7qM.html" rel="bookmark" class="title">String C&plus;&plus;完整实现。</a>
					<div>
						String C++实现 改进: /* 版权信息:狼 文件名称:String.h 文件标识: 摘 要:对于上版本简易的String进行优化跟进. 改进 1.(将小块内存问题与大块分别对待)小内存块每个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgEZlK3.html" rel="bookmark" class="title">Precision&sol;Recall和ROC曲线与分类</a>
					<div>
						[混淆矩阵与Precision/Recall和ROC曲线的关系] Precision/Recall和ROC曲线的基本介绍可以看我的另一篇博客: http://blog.csdn.net/adminab ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lNGGW4.html" rel="bookmark" class="title">Maven多模块、Dubbo分布式服务框架的SpringMVC项目的基础搭建</a>
					<div>
						现互联网公司后端架构常用到Spring+SpringMVC+MyBatis,通过Maven来构建.通过学习,我已经掌握了基本的搭建过程,写下基础文章为而后的深入学习奠定基础. 首先说一下这篇文章的主要 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
